/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20120816-64 [Oct 13 2012]
 * Copyright (c) 2000 - 2012 Intel Corporation
 * 
 * Disassembly of ssdt3.dat, Sat Oct 13 04:28:49 2012
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000401 (1025)
 *     Revision         0x01
 *     Checksum         0x35
 *     OEM ID           "FUJ   "
 *     OEM Table ID     "SgTabl"
 *     OEM Revision     0x01110000 (17891328)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20051117 (537202967)
 */

DefinitionBlock ("ssdt3.aml", "SSDT", 1, "FUJ   ", "SgTabl", 0x01110000)
{
    External (\_SB_.PCI0.RP00, DeviceObj)
    External (\_SB_.PCI0.RP00.VGA_, DeviceObj)
    External (\EECP, MethodObj)    // 1 Arguments
    External (\GBAS, MethodObj)    // 1 Arguments
    External (\GDGP, IntObj)
    External (\PGPU, MethodObj)    // 4 Arguments
    External (\RGPU, MethodObj)    // 7 Arguments
    External (\XBAS, MethodObj)    // 1 Arguments
    External (GPRW, IntObj)
    External (PWEN)
    External (SGMD)

    Scope (\_SB.PCI0.RP00)
    {
        OperationRegion (RPCI, PCI_Config, Zero, 0xF0)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
            Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1
        }

        OperationRegion (RPCX, SystemMemory, \XBAS (0x8400), Field (RPCX, DWordAcc, NoLock, Preserve)
            {
                Offset (0x8214), 
                Offset (0x8216), 
                LNKS,   4
            })
        Device (PEGA)
        {
            Name (_ADR, One)  // _ADR: Address
            OperationRegion (ACAP, PCI_Config, \EECP (0x14), Field (ACAP, DWordAcc, NoLock, Preserve)
                {
                    Offset (0x10), 
                    LCT1,   16
                })
            Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
            {
                Return (GPRW)
                0x09
                0x04
            }
        }
    }

    Scope (\_SB.PCI0.RP00.VGA)
    {
        Name (ELCT, Zero)
        Name (HVID, Zero)
        Name (HDID, Zero)
        OperationRegion (PCIS, PCI_Config, Zero, 0xF0)
        Field (PCIS, DWordAcc, Lock, Preserve)
        {
            DVID,   16, 
            Offset (0x2C), 
            SVID,   16, 
            SDID,   16, 
            Offset (0x4C), 
            WVID,   16, 
            WDID,   16
        }

        OperationRegion (GPIO, SystemIO, \GBAS (0x60), Field (GPIO, ByteAcc, Lock, Preserve)
            {
                Offset (0x0C), 
                LVL0,   32, 
                Offset (0x38), 
                LVL1,   32, 
                Offset (0x48), 
                LVL2,   32
            })
        OperationRegion (PCAP, PCI_Config, \EECP (0x14), Field (PCAP, DWordAcc, NoLock, Preserve)
            {
                Offset (0x10), 
                LCTL,   16
            })
        Method (SGON, 0, Serialized)
        {
            If (LEqual (SGPI (PWEN), Zero))
            {
                \RGPU (One, Sleep (0x32), \PGPU (One, Sleep (0x012C), \RGPU (Zero, 
                    Sleep (0x64), Store (Zero, LNKD), While (LLess (LNKS, 0x07))
                            {
                                Sleep (One)
                            }, Or (And (ELCT, 0x43), And (LCTL, 0xFFBC
                                    ), LCTL), Or (And (ELCT, 0x43), And (\_SB.PCI0.RP00.PEGA.LCT1, 0xFFBC), 
                                    \_SB.PCI0.RP00.PEGA.LCT1), Return (One))))
            }
        }

        Method (SGOF, 0, Serialized)
        {
            Store (LCTL, ELCT)
            Store (SVID, HVID)
            Store (SDID, HDID)
            Store (One, LNKD)
            While (LNotEqual (LNKS, Zero))
            {
                Sleep (One)
            }

            \RGPU (One, \PGPU (Zero, Return (Zero)))
        }

        Method (SGST, 0, Serialized)
        {
            Store (\GDGP, Local0)
            If (And (SGMD, 0x0F))
            {
                If (LEqual (Local0, Zero))
                {
                    Return (Zero)
                }

                Return (0x0F)
            }

            If (LNotEqual (DVID, 0xFFFF))
            {
                Return (0x0F)
            }

            Return (Zero)
        }

        Method (SGPI, 1, Serialized)
        {
            ShiftRight (Arg0, 0x07, Local1)
            And (Arg0, 0x7F, Arg0)
            If (LLess (Arg0, 0x20))
            {
                Store (\_SB.PCI0.RP00.VGA.LVL0, Local0)
                ShiftRight (Local0, Arg0, Local0)
            }
            Else
            {
                If (LLess (Arg0, 0x40))
                {
                    Store (\_SB.PCI0.RP00.VGA.LVL1, Local0)
                    ShiftRight (Local0, Subtract (Arg0, 0x20), Local0)
                }
                Else
                {
                    Store (\_SB.PCI0.RP00.VGA.LVL2, Local0)
                    ShiftRight (Local0, Subtract (Arg0, 0x40), Local0)
                }
            }

            If (LEqual (Local1, Zero))
            {
                Not (Local0, Local0)
            }

            Return (And (Local0, One))
        }

        Method (SGPO, 2, Serialized)
        {
            ShiftRight (Arg0, 0x07, Local3)
            And (Arg0, 0x7F, Arg0)
            If (LEqual (Local3, Zero))
            {
                Not (Arg1, Local3)
                And (Local3, One, Local3)
            }
            Else
            {
                And (Arg1, One, Local3)
            }

            If (LLess (Arg0, 0x20))
            {
                ShiftLeft (Local3, Arg0, Local0)
                ShiftLeft (One, Arg0, Local1)
                And (\_SB.PCI0.RP00.VGA.LVL0, Not (Local1), Local2)
                Or (Local2, Local0, \_SB.PCI0.RP00.VGA.LVL0)
            }
            Else
            {
                If (LLess (Arg0, 0x40))
                {
                    ShiftLeft (Local3, Subtract (Arg0, 0x20), Local0)
                    ShiftLeft (One, Subtract (Arg0, 0x20), Local1)
                    And (\_SB.PCI0.RP00.VGA.LVL1, Not (Local1), Local2)
                    Or (Local2, Local0, \_SB.PCI0.RP00.VGA.LVL1)
                }
                Else
                {
                    If (LLess (Arg0, 0x7F))
                    {
                        ShiftLeft (Local3, Subtract (Arg0, 0x40), Local0)
                        ShiftLeft (One, Subtract (Arg0, 0x40), Local1)
                        And (\_SB.PCI0.RP00.VGA.LVL2, Not (Local1), Local2)
                        Or (Local2, Local0, \_SB.PCI0.RP00.VGA.LVL2)
                    }
                }
            }

            Return (One)
        }
    }
}

